using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using System.Diagnostics;

namespace Sheng.Winform.Controls.Kernal
{
    /// <summary>
    /// 
    /// </summary>
    public class ConstructorInvokerPool : FastReflectionPool<Type[], IConstructorInvoker>
    {
        /// <summary>
        /// 
        /// </summary>
        public ConstructorInvokerPool()
        {
            CustomCompare = true;
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="key1"></param>
        /// <param name="key2"></param>
        /// <returns></returns>
        protected override bool Compare(Type[] key1, Type[] key2)
        {
            return key1.SequenceEqual(key2);
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="type"></param>
        /// <param name="key"></param>
        /// <returns></returns>
        protected override IConstructorInvoker Create(Type type, Type[] key)
        {
            if (type == null || key == null)
            {
                Debug.Assert(false, "type 或 key 为空");
                throw new ArgumentNullException();
            }

            ConstructorInfo constructorInfo = type.GetConstructor(key);

            if (constructorInfo == null)
            {
                Debug.Assert(false, "没有指定的ConstructorInfo");
                throw new InvalidOperationException();
            }

            return new ConstructorInvoker(constructorInfo);
        }
    }
}
